unit SubRut;
{ rutiineja }

interface

uses classes;

{ etsii stringlistasta indexin, jonka merkkijonon alku on sama kuin S }
function StringIndexL(SL: TStrings; const S: string): Integer;

{ hakee merkkijonosta seuraavan indexin Ix jlkeisen luvun }
function StrToNextInt(const S: String; var Ix: Integer): Integer;

{ hakee merkkijonosta indexi Ix edeltvn luvun }
function StrToPrevInt(const S: String; var Ix: Integer): Integer;

{ merkkijonon alussa oleva numero }
function StrToFirstInt(const S: String; Ix: Integer): Integer;

{ hakee merkkijonosta seuraavan indexin Ix jlkeisen 2-numeroisen luvun = desimaalit }
function StrToDes2(const S: String; var Ix: Integer): Integer;

{ valuuttaluvun muunto kokonaisluvuksi (senttein) }
function SumTxtToInt(const S: String): Integer;

{ hakee merkkien C1 ja C2 vliss olevan merkkijonon paikasta Ix lhtien.
  Jos C1=#0, alkaa merkkijono Ix:st. Jos C2=#0, loppuu merkkijono S:n loppuun }
function StrFromStr(const S: String; C1, C2: Char; var Ix: Integer): String;

{ palauttaa Char-merkkijonon, jonka pituus on Kpl}
function SpaceStr(Kpl: Integer; C: Char): String;

{ merkkijonon alusta numeromerkkien mr }
function NumLength(S: String): Integer;

// kutenIntToStr, mutta listn desimaalipiste
function IntToStrDes(Ix, Des: Integer): String;

// Muuntaa editoidun luvun desimaalit ensin Des-pituiseksi, sitten muuntaa sen integeriksi
function CellToIntDes(const S: String; Des: Integer): Integer;

const
  DesP = ',';           // ohjelman kyttm desimaalierotin
  DesP2 = '.';          // lukueditoinnissa voi kytt ttkin

implementation

uses sysutils;

{ etsii stringlistasta indexin, jonka merkkijonon alku on sama kuin S }
function StringIndexL(SL: TStrings; const S: string): Integer;
var
  L, H, I, C, P: Integer;
begin
  Result := -1;
  P := Length(S);
  L := 0;
  H := SL.Count - 1;
  if P > 0 then
  while L <= H do
  begin
    I := (L + H) shr 1;
    C := AnsiStrLIComp(PChar(SL[I]), PChar(S), Length(S));
    if C < 0 then L := I + 1 else
    begin
      H := I - 1;
      if C = 0 then
      begin
        Result := I;
        Break;
      end;
    end;
  end;
end;

{ hakee merkkijonosta seuraavan indexin Ix jlkeisen luvun }
function StrToNextInt(const S: String; var Ix: Integer): Integer;
var
  ApuI: Integer;
begin
  while (Ix <= Length(S)) and not (S[Ix] in ['-', '0'..'9']) do Inc(Ix);
  ApuI := Ix;
  while (Ix <= Length(S)) and (S[Ix] in ['-', '0'..'9']) do Inc(Ix);
  if (ApuI <= Length(S)) and (Ix > ApuI)
  then Result := StrToIntDef(Copy(S, ApuI, Ix - ApuI), 0)
  else Result := 0;
end;

{ hakee merkkijonosta indexi Ix edeltvn luvun }
function StrToPrevInt(const S: String; var Ix: Integer): Integer;
var
  ApuI: Integer;
begin
  if Ix > Length(S) then Ix := Length(S);
  while (Ix > 0) and not (S[Ix] in ['-', '0'..'9']) do Dec(Ix);
  ApuI := Ix;
  while (Ix > 0) and (S[Ix] in ['-', '0'..'9']) do Dec(Ix);
  if ApuI > Ix
  then Result := StrToIntDef(Copy(S, Ix+1, ApuI - Ix), 0)
  else Result := 0;
end;


{ merkkijonon alussa oleva numero }
function StrToFirstInt(const S: String; Ix: Integer): Integer;
var
  Iy: Integer;
begin
  Iy := Ix;
  while (Ix <= Length(S)) and (S[Ix] in ['-', '0'..'9']) do Inc(Ix);
  if (Ix > Iy)
  then Result := StrToIntDef(Copy(S, Iy, Ix - Iy), 0)
  else Result := 0;
end;

{ hakee merkkijonosta seuraavan indexin Ix jlkeisen 2-numeroisen luvun = desimaalit }
function StrToDes2(const S: String; var Ix: Integer): Integer;
var
  ApuI: Integer;
begin
  while (Ix <= Length(S)) and not (S[Ix] in ['0'..'9']) do Inc(Ix);
  ApuI := Ix;
  if (Ix <= Length(S)) and (S[Ix] in ['-', '0'..'9']) then Inc(Ix);
  if (Ix <= Length(S)) and (S[Ix] in ['-', '0'..'9']) then Inc(Ix);
  if (ApuI <= Length(S)) and (Ix > ApuI) then
  begin
    Result := StrToIntDef(Copy(S, ApuI, Ix - ApuI), 0);
    if Ix - ApuI = 1 then Result := Result * 10;
  end
  else Result := 0;
end;

{ valuuttaluvun muunto kokonaisluvuksi (senttein) }
function SumTxtToInt(const S: String): Integer;
var
  Ix, Iy, ApuI: Integer;
begin
  Ix := 1;
  Result := StrToNextInt(S, Ix) * 100;
  ApuI := StrToDes2(S, Ix);
  Iy := Pos('-', S);
  if (Iy > 0) and (Iy < Ix) then Dec(Result, ApuI) else Inc(Result, ApuI);
end;

{ hakee merkkien C1 ja C2 rajoittaman merkkijonon }
function StrFromStr(const S: String; C1, C2: Char; var Ix: Integer): String;
var
  ApuI: Integer;
begin
  if C1 <> #0 then
  begin
    while (Ix <= Length(S)) and (S[Ix] <> C1) do Inc(Ix);
    Inc(Ix);
  end;  
  ApuI := Ix;
  if C2 = #0 then Ix := Length(S) + 1
  else while (Ix <= Length(S)) and (S[Ix] <> C2) do Inc(Ix);
  if (Ix > ApuI)
  then Result := Copy(S, ApuI, Ix - ApuI)
  else Result := '';
end;

{ palauttaa Char-merkkijonon, jonka pituus on Kpl}
function SpaceStr(Kpl: Integer; C: Char): String;
begin
  Result := '';
  if Kpl > 0 then
  begin
    SetLength(Result, Kpl);
    FillChar(Result[1], Kpl, C);
  end;
end;

function NumLength(S: String): Integer;
begin
  Result := 1;
  while (Result <= Length(S)) and (S[Result] in ['0'..'9']) do Inc(Result);
  Dec(Result);
end;

function IntToStrDes(Ix, Des: Integer): String;
begin
  Result := IntToStr(Ix);
  while Length(Result) <= Des do Result := '0' + Result;
  if Des > 0 then Insert(DesP, Result, Length(Result) - Des + 1);
end;

// Muuntaa editoidun luvun desimaalit ensin Des-pituiseksi, sitten muuntaa sen integeriksi
function CellToIntDes(const S: String; Des: Integer): Integer;
var
  ApuI, Pyor: Integer;
  ApuS: String;
begin
  ApuS := S;
  Pyor := 0;
  ApuI := Pos(DesP2, ApuS);
  if ApuI = 0 then ApuI := Pos(DesP, ApuS);
  if ApuI > 0
  then Delete(ApuS, ApuI, 1)       // poistetaan desimaalierotin
  else ApuI := Length(ApuS) + 1;   // osoittaa kokonaislukujen jlkeiseen paikkaan
  Dec(ApuI);   // ApuI = kokonaislukuosan pituus
  if Length(ApuS) > (ApuI + Des) then
  begin
    if Ord(ApuS[ApuI + Des + 1]) > Ord('4') then Pyor := 1;   // jos katkaistava numero > 4, pyristetn yls
    SetLength(ApuS, ApuI + Des);
  end
  else
  while Length(ApuS) < (ApuI + Des) do ApuS := ApuS + '0';
  Result := StrToIntDef(ApuS, 0) + Pyor;
end;


end.
